﻿using GrapeCity.Windows.SpreadSheet.Data;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BorderDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            gcSpreadSheet1.ActiveSheet.ColumnCount = 4;
            this.gcSpreadSheet1.Workbook.VerticalScrollBarVisibility = ScrollBarVisibility.Hidden;
            this.gcSpreadSheet1.Workbook.HorizontalScrollBarVisibility = ScrollBarVisibility.Hidden;
            this.gcSpreadSheet1.TabStripVisibility = Visibility.Collapsed;
            this.gcSpreadSheet1.ColumnWidthChanged += GcSpreadSheet1_ColumnWidthChanged;
            this.gcSpreadSheet1.MouseLeftButtonUp += GcSpreadSheet1_MouseLeftButtonUp;
            ResizeColumn();
        }
        bool isLastColumn = false;
        private void GcSpreadSheet1_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Point location = e.GetPosition(this.gcSpreadSheet1);
            if (isLastColumn)
            {
                double change= (location.X-this.gcSpreadSheet1.Width);
                if (change > 0)
                {
                    this.gcSpreadSheet1.ActiveSheet.Columns[this.gcSpreadSheet1.ActiveSheet.ColumnCount - 1].Width += change;
                    this.gcSpreadSheet1.Width += change;
                }
            }
        }
        private void GcSpreadSheet1_ColumnWidthChanged(object sender, GrapeCity.Windows.SpreadSheet.UI.ColumnWidthChangedEventArgs e)
        {
            isLastColumn = false;
            ResizeColumn();
            if (e.ColumnList[0] == this.gcSpreadSheet1.ActiveSheet.Columns.Count-1)
            {
                isLastColumn = true;
            }
        }

        void ResizeColumn()
        {
            double newWidth = 0;
            newWidth = this.gcSpreadSheet1.ActiveSheet.RowHeader.DefaultColumnWidth;
            for (int i = 0; i < this.gcSpreadSheet1.ActiveSheet.Columns.Count; i++)
            {
                newWidth += this.gcSpreadSheet1.ActiveSheet.Columns[i].Width;
            }
            this.gcSpreadSheet1.Width = newWidth+2;
        }
    }
}
